#version 330 core

layout (location = 0) in vec4 vInPos;   // the position attribute
layout (location = 1) in vec4 vInColor; // the color attribute

out vec4 vPos;
out vec4 vColor;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;

void main()
{
	vPos = model * vec4(vInPos.xyz, 1);
	vColor = vInColor.bgra;

    gl_Position = projection * view * vPos;
	gl_PointSize = 4 / gl_Position.z;
	
	if(gl_Position.z < 0.05)
		gl_PointSize = 0;
}